'use strict';

/**
 * 
 * @module algojs-sorting/lib/ordering 
 */


/**
 * 
 * @constructor
 */
var Ordering = function() {
  /**
   * @abstract
   * @param a
   * @param b
   */
  this.compare = function(a, b) {
    throw 'UnsupportedOperationException';
  }
};

/**
 * 
 * @param fn
 */
Ordering.by = function(fn) {
  var By = function() {
    this.compare = function(a, b) {
      return fn(a, b);
    }
  };
  By.prototype = Object.create(Ordering.prototype);
  By.prototype.constructor = Ordering.constructor;
  
};


module.exports = {
  
  Ordering: Ordering
};